unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IBDatabase, DB, ExtCtrls, DBCtrls, IBCustomDataSet, IBTable,
  ExtDlgs, StdCtrls, JPEG, IBQuery, IBUpdateSQL;

type
  TForm1 = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    DBNavigator1: TDBNavigator;
    Panel1: TPanel;
    Image1: TImage;
    DataSource1: TDataSource;
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    IBQuery1: TIBQuery;
    IBQuery1FOTO: TBlobField;
    IBUpdateSQL1: TIBUpdateSQL;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  Db: string;
begin
  Db := ExtractFilePath(Application.ExeName) + 'teste.fdb';
  IBDatabase1.DatabaseName := Db;
  IBDatabase1.Connected := True;
  IBTransaction1.Active := True;
  IBQuery1.Open;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IBTransaction1.Commit;
  IBQuery1.Close;
  IBDatabase1.Connected := False;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  FileStream: TFileStream;
  BlobStream: TStream;
begin
  if OpenPictureDialog1.Execute then
    begin
      IBQuery1.Append;
      FileStream := TFileStream.Create(OpenPictureDialog1.FileName,
        fmOpenRead or fmShareDenyWrite);
      BlobStream := IBQuery1.CreateBlobStream(IBQuery1FOTO, bmWrite);
      try
        BlobStream.CopyFrom(FileStream, FileStream.Size);
      finally
        FileStream.Free;
        BlobStream.Free;
      end;
    end;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var
  BlobStream: TStream;
  JPEGImage: TJPEGImage;
begin
  if IBQuery1FOTO.BlobSize <> 0 then
    begin
      BlobStream := IBQuery1.CreateBlobStream(IBQuery1FOTO, bmRead);
      JPEGImage := TJPEGImage.Create;
      try
        JPEGImage.LoadFromStream(BlobStream);
        Image1.Picture.Assign(JPEGImage);
      finally
        BlobStream.Free;
        JPEGImage.Free;
      end;
    end
  else
    Image1.Picture := nil;
end;

end.
